--[[ ### Ping Kick Script v2 ###]]--
--[[ ###     by H® Shaft     ###]]--
--[[ ###    for Phasor v2    ###]]--
--[[ ###  other thanks below ###]]--

max_ping = 365 -- Max Ping: edit as needed  
pingkick_timeout = 1 -- After this many minutes any player warned of high ping will be forgotten. - edit as needed
--don't edit:
pingwarned = {} -- Table of players who have been warned for high ping

function GetRequiredVersion()
	return 200
end

function OnScriptLoad(process, game, persistent)

end

function OnNewGame(map)
	
	pingwarned = {}
	pingtimer = registertimer(30000, "pingkickTimer") -- check all players pings every 3 minutes
	pingtimeouter = registertimer(pingkick_timeout * 60000, "pingTimeout") 
end	

function pingTimeout(id, count)  --re-evaluate warn or kick
	for i = 0,15 do
		if getplayer(i) ~= nil then
			pingwarned[gethash(i)] = nil
		end
	end
end

function pingkickTimer(id, count)
	for i = 0,15 do
		local m_player = getplayer(i)
		if m_player ~= nil then
			local player_ping = readword(m_player, 0xDC)
			if player_ping > max_ping then
				if pingwarned[gethash(i)] ~= nil then
					say(getname(i) .. " was kicked for having a ping over " .. max_ping .. "ms.")
					svcmd("sv_kick " .. resolveplayer(i))
				else
					registertimer(1000, "pingwarn")
				end
			end
		end
	end
	return 1
end

function OnPlayerLeave(player)
	pingwarned[gethash(player)] = nil
end	

function pingwarn(id, count)  --warns player they will be kicked, tells them their ping
	if count == 1 then
		for i = 0,15 do
			local m_player = getplayer(i)
			if m_player ~= nil then
				local player_ping = readword(m_player, 0xDC)
				if player_ping > max_ping then
					if pingwarned[gethash(i)] == nil then
						pingwarned[gethash(i)] = true
						privatesay(i, "WARNING: Your Ping:" .. player_ping .. "ms. You will be kicked if your ping is over " .. max_ping .. "ms.")
						privatesay(i, "You have " .. pingkick_timeout .. " minute(s) to solve it before being kicked.")
					end
				end
			end
		end
	end
return 1
end

-- Thanks to H® BugZ, Oxide, Elite Prime, Nugget & Wizard & many others for their contributions to Phasor and the Halo Community
-- 365 is high limit for UK connecting to US server, 333 is too low and will kick even though UK player is not warping nor having packet loss (lag)
-- for regional ping limits (client to host) that is stable such as Chicago to New York a good high is 250 which means UK players would get warned/kicked quickly